--------------------------------------------------------------------------
--                                                                      --
--           Copyright: Copyright (C) 2000-2010 CNRS/IN2P3              --
--                                                                      --
-- Narval framework is free  software; you can redistribute  it and/or  --
-- modify  it   under  terms  of  the  GNU General  Public  License as  --
-- published  by  the  Free Software Foundation; either version  2, or  --
-- (at your option) any later version. Narval framework is distributed  --
-- in the hope  that  they will  be useful, but  WITHOUT ANY WARRANTY;  --
-- without even the implied warranty of  MERCHANTABILITY or FITNESS FOR --
-- A PARTICULAR PURPOSE. See the  GNU. General Public License for more  --
-- details. You should have received  a copy of the GNU General Public  --
-- License distributed with Narval; see file COPYING. If not, write to  --
-- the Free Software  Foundation,  Inc., 51 Franklin St,  Fifth Floor,  --
-- Boston, MA 02110-1301 USA.                                           --
--------------------------------------------------------------------------

--  wsdl2aws SOAP Generator v2.0
--
--  AWS 2.2.0 - SOAP 1.4.0
--  This file was generated on Wednesday 06 February 2008 at 10:05:06
--
--  $ wsdl2aws -spec narval_aws_interface -f -main aws_interface_main -cb narval_aws.wsdl

pragma Warnings (Off);

with Ada.Calendar;

with AWS.Status;
pragma Elaborate_All (AWS.Status);
with AWS.Response;
pragma Elaborate_All (AWS.Response);

with SOAP.Message.Payload;
pragma Elaborate_All (SOAP);
pragma Elaborate_All (SOAP.Message);
pragma Elaborate_All (SOAP.Message.Payload);
with SOAP.Types;
pragma Elaborate_All (SOAP.Types);

with narval_aws_Service.Types;
pragma Elaborate_All (narval_aws_Service.Types);

package narval_aws_Service.Server is

   use narval_aws_Service.Types;

   Port : constant := 6080;

   generic
      with function Send_Command
        (Command  : in String)
         return String;
   function Send_Command_CB
     (SOAPAction : in String;
      Payload    : in SOAP.Message.Payload.Object;
      Request    : in AWS.Status.Data)
      return AWS.Response.Data;

   generic
      with function Send_Command_With_Arguments
        (Command   : in String;
         Arguments : in String_Array_Type)
         return String;
   function Send_Command_With_Arguments_CB
     (SOAPAction : in String;
      Payload    : in SOAP.Message.Payload.Object;
      Request    : in AWS.Status.Data)
      return AWS.Response.Data;

end narval_aws_Service.Server;
